From: martinRenou <martin.renou@gmail.com>
Date: Thu, 28 Jul 2022 11:33:00 +0200
Subject: GHSL-2021-1018

Origin: https://github.com/jupyter/nbconvert/commit/4b9c5e76bad57eedf1d3cdba244bb05811f64536
Bug: https://github.com/jupyter/nbconvert/security/advisories/GHSA-9jmq-rx5f-8jwq
Bug-Debian: https://security-tracker.debian.org/tracker/CVE-2021-32862
---
 .../exporters/tests/files/notebook_inject.ipynb     | 21 +++++++++++++++++++--
 nbconvert/exporters/tests/test_html.py              |  3 +++
 nbconvert/templates/html/basic.tpl                  |  2 +-
 3 files changed, 23 insertions(+), 3 deletions(-)

diff --git a/nbconvert/exporters/tests/files/notebook_inject.ipynb b/nbconvert/exporters/tests/files/notebook_inject.ipynb
index 75d2d97..14986d0 100644
--- a/nbconvert/exporters/tests/files/notebook_inject.ipynb
+++ b/nbconvert/exporters/tests/files/notebook_inject.ipynb
@@ -25,7 +25,24 @@
     "source": [
       "<script>alert('markdown cell')</script>"
     ]
-  }
+  },
+  {
+    "cell_type": "code",
+    "execution_count": null,
+    "id": "b72e53fa",
+    "metadata": {},
+    "outputs": [
+     {
+      "output_type": "execute_result",
+      "data": {
+        "image/svg+xml": ["<script>alert('image/svg+xml output')</script>"]
+      },
+      "execution_count": null,
+      "metadata": {}
+     }
+    ],
+    "source": [""]
+   }
  ],
  "metadata": {
   "title": "TITLE</title><script>alert('title')</script>",
@@ -47,7 +64,7 @@
    "version": "3.10.5"
   },
   "widgets": {
-    "application/vnd.jupyter.widget-state+json": {"foo": "pwntester</script><script>alert('widgets');//"}
+    "application/vnd.jupyter.widget-state+json": {"state": "{}", "foo": "pwntester</script><script>alert('widgets');//"}
   }
  },
  "nbformat": 4,
diff --git a/nbconvert/exporters/tests/test_html.py b/nbconvert/exporters/tests/test_html.py
index 1987f57..a00286c 100644
--- a/nbconvert/exporters/tests/test_html.py
+++ b/nbconvert/exporters/tests/test_html.py
@@ -156,3 +156,6 @@ class TestHTMLExporter(ExportersTestsBase):
             # Check injection in the cell.source of the Notebook
             assert "<script>alert('raw cell')</script>" not in output
             assert "<script>alert('markdown cell')</script>" not in output
+
+            # Check injection in svg output
+            assert "<script>alert('image/svg+xml output')</script>" not in output
diff --git a/nbconvert/templates/html/basic.tpl b/nbconvert/templates/html/basic.tpl
index 84a83ec..ba64342 100644
--- a/nbconvert/templates/html/basic.tpl
+++ b/nbconvert/templates/html/basic.tpl
@@ -126,7 +126,7 @@ unknown type  {{ cell.type }}
 {%- if output.svg_filename %}
 <img src="{{ output.svg_filename | posix_path }}">
 {%- else %}
-{{ output.data['image/svg+xml'] }}
+{{ output.data['image/svg+xml'] | clean_html }}
 {%- endif %}
 </div>
 {%- endblock data_svg %}
